import processing.core.*; 
import processing.data.*; 
import processing.event.*; 
import processing.opengl.*; 

import java.util.HashMap; 
import java.util.ArrayList; 
import java.io.File; 
import java.io.BufferedReader; 
import java.io.PrintWriter; 
import java.io.InputStream; 
import java.io.OutputStream; 
import java.io.IOException; 

public class cs112BallExample2 extends PApplet {

ball[] b;
int nb = 100;

public void setup(){
  size(600,400);
  b = new ball[nb];
  for(int i = 0; i < nb ; i++){
    b[i] = new ball();
  }
  frameRate(100);
}

public void draw(){
  background(200);
  for(int i = 0; i < nb ; i++){
    b[i].display();
    b[i].update();
  }

}
class ball{
  float x;
  float y;
  float xvelocity;
  float yvelocity;
  float bounciness;
  
  ball(){
    x = width*random(0.2f,0.7f);
    y = 0;
    xvelocity = random(-1,1);
    yvelocity = 0;
    bounciness = 1.0f - random(0.001f,0.1f);  // balls have a random bounciness slightly below 1.
  }
  
  public void display(){
    fill(255,100,200);
    ellipse(x,y,15,15);
  }
  
  public void update(){
    yvelocity = yvelocity*0.999f;  // "air resistance"
    x = x + xvelocity;
    y = y + yvelocity;
    yvelocity = yvelocity + 0.1f;
    if(y > height){
      yvelocity = yvelocity * (-1 * bounciness);
      y = height; // so the ball doesn't get "stuck" in the floor
    }
    if(x < 0){
      xvelocity = xvelocity * (-1 * bounciness);
      x = 0;
    }
    if(x > width){
      xvelocity = xvelocity * (-1 * bounciness);
      x = width;
    }
  }
}
  static public void main(String[] passedArgs) {
    String[] appletArgs = new String[] { "cs112BallExample2" };
    if (passedArgs != null) {
      PApplet.main(concat(appletArgs, passedArgs));
    } else {
      PApplet.main(appletArgs);
    }
  }
}
