class ball{
  float x;
  float y;
  float xvelocity;
  float yvelocity;
  float bounciness;
  
  ball(){
    x = width*random(0.2,0.7);
    y = 0;
    xvelocity = random(-1,1);
    yvelocity = 0;
    bounciness = 1.0 - random(0.001,0.1);  // balls have a random bounciness slightly below 1.
  }
  
  void display(){
    fill(255,100,200);
    ellipse(x,y,15,15);
  }
  
  void update(){
    yvelocity = yvelocity*0.999;  // "air resistance"
    x = x + xvelocity;
    y = y + yvelocity;
    yvelocity = yvelocity + 0.1;
    if(y > height){
      yvelocity = yvelocity * (-1 * bounciness);
      y = height; // so the ball doesn't get "stuck" in the floor
    }
    if(x < 0){
      xvelocity = xvelocity * (-1 * bounciness);
      x = 0;
    }
    if(x > width){
      xvelocity = xvelocity * (-1 * bounciness);
      x = width;
    }
  }
}
